#!/bin/sh

DM_SVN_URL=https://subversion.xray.aps.anl.gov/DataManagement

MY_DIR=`dirname $0` && cd $MY_DIR && MY_DIR=`pwd`
if [ -z "${DM_ROOT_DIR}" ]; then
    DM_ROOT_DIR=$MY_DIR/..
fi
DM_SUPPORT=$DM_ROOT_DIR/../support

execute() {
    echo "Executing: $@"
    eval "$@"
}

if [ ! -d $DM_SUPPORT ]; then
    echo "Creating new DM support directory $DM_SUPPORT."
    cd `dirname $DM_SUPPORT`
    execute svn co $DM_SVN_URL/support support
fi
cd $DM_SUPPORT
execute svn update
execute $DM_SUPPORT/bin/clean_all.sh
execute $DM_SUPPORT/bin/install_all.sh



