/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package gov.anl.aps.dm.portal.model.entities;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;

/**
 *
 * @author sveseli
 */
@Entity
@Table(name = "experiment_policy")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "ExperimentPolicy.findAll", query = "SELECT e FROM ExperimentPolicy e"),
    @NamedQuery(name = "ExperimentPolicy.findById", query = "SELECT e FROM ExperimentPolicy e WHERE e.id = :id"),
    @NamedQuery(name = "ExperimentPolicy.findByPolicyValue", query = "SELECT e FROM ExperimentPolicy e WHERE e.policyValue = :policyValue"),
    @NamedQuery(name = "ExperimentPolicy.findByDescription", query = "SELECT e FROM ExperimentPolicy e WHERE e.description = :description")})
public class ExperimentPolicy extends CloneableEntity
{
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Basic(optional = false)
    @Column(name = "id")
    private Integer id;
    @Basic(optional = false)
    @Size(min = 1, max = 2147483647)
    @Column(name = "policy_value")
    private String policyValue;
    @Size(max = 2147483647)
    @Column(name = "description")
    private String description;
    @JoinColumn(name = "policy_type_id", referencedColumnName = "id")
    @ManyToOne(optional = false)
    private PolicyType policyType;
    @JoinColumn(name = "experiment_id", referencedColumnName = "id")
    @ManyToOne(optional = false)
    private Experiment experiment;

    public ExperimentPolicy() {
    }

    public ExperimentPolicy(Integer id) {
        this.id = id;
    }

    public ExperimentPolicy(Integer id, String value) {
        this.id = id;
        this.policyValue = value;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getPolicyValue() {
        return policyValue;
    }

    public void setPolicyValue(String policyValue) {
        this.policyValue = policyValue;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public PolicyType getPolicyType() {
        return policyType;
    }

    public void setPolicyType(PolicyType policyType) {
        this.policyType = policyType;
    }

    public Experiment getExperiment() {
        return experiment;
    }

    public void setExperiment(Experiment experiment) {
        this.experiment = experiment;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof ExperimentPolicy)) {
            return false;
        }
        ExperimentPolicy other = (ExperimentPolicy) object;
        if ((this.id == null && other.id != null) || (this.id != null && !this.id.equals(other.id))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "gov.anl.aps.dm.portal.model.entities.ExperimentPolicy[ id=" + id + " ]";
    }
    
}
