#!/usr/bin/env python

#
# Base object manager class.
#

#######################################################################

import threading
from dm.common.utility import loggingManager

#######################################################################

class DmObjectManager:
    """ Base object manager class. """

    def __init__(self):
        self._logger = loggingManager.getLogger(self.__class__.__name__)
        self._lock = threading.RLock()

    def getLogger(self):
        return self._logger

    def acquireLock(self):
        self._lock.acquire()

    def releaseLock(self):
        self._lock.release()

