#!/usr/bin/env python

#
# Implementation for file system controller.
#

#######################################################################

import threading

from dm.common.objects.dmObject import DmObject
from dm.common.objects.dmObjectManager import DmObjectManager
from dm.common.utility.dmSubprocess import DmSubprocess

#######################################################################

class FsControllerImpl(DmObjectManager):
    """ FS controller implementation class. """

    def __init__(self):
        DmObjectManager.__init__(self)

    def getDirectoryList(self, path):
        p = DmSubprocess('ls -l %s' % path)
        p.run()
        return DmObject({'path' : path, 'directoryList' : p.getStdOut()})
